Index: /branches/nemo_v3_3_beta/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_lim_2.F90
===================================================================
--- /branches/nemo_v3_3_beta/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_lim_2.F90	(revision 2369)
+++ /branches/nemo_v3_3_beta/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_lim_2.F90	(revision 2370)
@@ -2,7 +2,6 @@
    !!======================================================================
    !!                       ***  MODULE  sbcice_lim_2  ***
-   !! Surface module :  update surface ocean boundary condition over ice
-   !!                   covered area using LIM sea-ice model
-   !! Sea-Ice model  :  LIM 2.0 Sea ice model time-stepping
+   !! Surface module :  update surface ocean boundary condition over ice covered area using LIM sea-ice model
+   !! Sea-Ice model  :  LIM-2 Sea ice model time-stepping
    !!======================================================================
    !! History :  1.0   !  06-2006  (G. Madec)  from icestp_2.F90
@@ -12,12 +11,10 @@
 #if defined key_lim2
    !!----------------------------------------------------------------------
-   !!   'key_lim2' :                                  LIM 2.0 sea-ice model
-   !!----------------------------------------------------------------------
-   !!   sbc_ice_lim_2  : sea-ice model time-stepping and
-   !!                    update ocean sbc over ice-covered area
-   !!----------------------------------------------------------------------
-   USE oce             ! ocean dynamics and tracers
-   USE dom_oce         ! ocean space and time domain
-   USE lib_mpp
+   !!   'key_lim2' :                                    LIM-2 sea-ice model
+   !!----------------------------------------------------------------------
+   !!   sbc_ice_lim_2   : sea-ice model time-stepping and update ocean sbc over ice-covered area
+   !!----------------------------------------------------------------------
+   USE oce              ! ocean dynamics and tracers
+   USE dom_oce          ! ocean space and time domain
    USE ice_2
    USE par_ice_2
@@ -25,26 +22,27 @@
    USE dom_ice_2
 
-   USE sbc_oce         ! Surface boundary condition: ocean fields
-   USE sbc_ice         ! Surface boundary condition: ice   fields
-   USE sbcblk_core     ! Surface boundary condition: CORE bulk
-   USE sbcblk_clio     ! Surface boundary condition: CLIO bulk
-   USE sbccpl          ! Surface boundary condition: coupled interface
+   USE sbc_oce          ! Surface boundary condition: ocean fields
+   USE sbc_ice          ! Surface boundary condition: ice   fields
+   USE sbcblk_core      ! Surface boundary condition: CORE bulk
+   USE sbcblk_clio      ! Surface boundary condition: CLIO bulk
+   USE sbccpl           ! Surface boundary condition: coupled interface
    USE albedo
 
-   USE phycst          ! Define parameters for the routines
-   USE eosbn2          ! equation of state
+   USE phycst           ! Define parameters for the routines
+   USE eosbn2           ! equation of state
    USE limdyn_2
    USE limtrp_2
    USE limdmp_2
    USE limthd_2
-   USE limsbc_2        ! sea surface boundary condition
+   USE limsbc_2         ! sea surface boundary condition
    USE limdia_2
    USE limwri_2
    USE limrst_2
 
-   USE lbclnk
-   USE iom             ! I/O manager library
-   USE in_out_manager  ! I/O manager
-   USE prtctl          ! Print control
+   USE lbclnk           ! lateral boundary condition - MPP link
+   USE lib_mpp          ! MPP library
+   USE iom              ! I/O manager library
+   USE in_out_manager   ! I/O manager
+   USE prtctl           ! Print control
 
    IMPLICIT NONE
@@ -59,7 +57,6 @@
    !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$
-   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
-   !!----------------------------------------------------------------------
-
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
 CONTAINS
 
@@ -97,21 +94,30 @@
          IF(lwp) WRITE(numout,*) 'sbc_ice_lim_2 : update ocean surface boudary condition' 
          IF(lwp) WRITE(numout,*) '~~~~~~~~~~~~~   via Louvain la Neuve Ice Model (LIM) time stepping'
-
+         !
          CALL ice_init_2
-
       ENDIF
 
-      IF( MOD( kt-1, nn_fsbc ) == 0 ) THEN
-         !
+      !                                        !----------------------!
+      IF( MOD( kt-1, nn_fsbc ) == 0 ) THEN     !  Ice time-step only  !
+         !                                     !----------------------!
+         !  Bulk Formulea !
+         !----------------!
          ! ... mean surface ocean current at ice dynamics point
-         !     B-grid dynamics :  I-point 
-         DO jj = 2, jpj
-            DO ji = 2, jpi   ! B grid : no vector opt.
-               u_oce(ji,jj) = 0.5 * ( ssu_m(ji-1,jj  ) + ssu_m(ji-1,jj-1) ) * tmu(ji,jj)
-               v_oce(ji,jj) = 0.5 * ( ssv_m(ji  ,jj-1) + ssv_m(ji-1,jj-1) ) * tmu(ji,jj)
+         SELECT CASE( cp_ice_msh )
+         CASE( 'I' )                  !== B-grid ice dynamics :   I-point (i.e. F-point with sea-ice indexation)
+            DO jj = 2, jpj
+               DO ji = 2, jpi   ! NO vector opt. possible
+                  u_oce(ji,jj) = 0.5_wp * ( ssu_m(ji-1,jj  ) + ssu_m(ji-1,jj-1) ) * tmu(ji,jj)
+                  v_oce(ji,jj) = 0.5_wp * ( ssv_m(ji  ,jj-1) + ssv_m(ji-1,jj-1) ) * tmu(ji,jj)
+               END DO
             END DO
-         END DO
-         CALL lbc_lnk( u_oce, 'I', -1. )   ! I-point (i.e. F-point with ice indices)
-         CALL lbc_lnk( v_oce, 'I', -1. )   ! I-point (i.e. F-point with ice indices)
+            CALL lbc_lnk( u_oce, 'I', -1. )   ! I-point (i.e. F-point with ice indices)
+            CALL lbc_lnk( v_oce, 'I', -1. )   ! I-point (i.e. F-point with ice indices)
+            !
+         CASE( 'C' )                  !== C-grid ice dynamics :   U & V-points (same as ocean)
+            u_oce(:,:) = ssu_m(:,:)                     ! mean surface ocean current at ice velocity point
+            v_oce(:,:) = ssv_m(:,:)
+            !
+         END SELECT
 
          ! ... masked sea surface freezing temperature [Kelvin] (set to rt0 over land)
@@ -142,5 +148,5 @@
                &                      qla_ice    , dqns_ice   , dqla_ice   ,            &
                &                      tprecip    , sprecip    ,                         &
-               &                      fr1_i0     , fr2_i0     , cl_grid    , jpl  )
+               &                      fr1_i0     , fr2_i0     , cp_ice_msh , jpl  )
 
          CASE( 4 )           ! CORE bulk formulation
@@ -149,5 +155,5 @@
                &                      qla_ice    , dqns_ice   , dqla_ice   ,            &
                &                      tprecip    , sprecip    ,                         &
-               &                      fr1_i0     , fr2_i0     , cl_grid    , jpl  )
+               &                      fr1_i0     , fr2_i0     , cp_ice_msh , jpl  )
          CASE( 5 )           ! Coupled formulation : atmosphere-ice stress only (fluxes provided after ice dynamics)
             CALL sbc_cpl_ice_tau( utau_ice , vtau_ice )
@@ -170,31 +176,40 @@
          !  Ice model step  !
          ! ---------------- !
-         numit = numit + nn_fsbc                                             !Ice model time step
-
-                                        CALL lim_rst_opn_2  ( kt )           ! Open Ice restart file
+         numit = numit + nn_fsbc                           ! Ice model time step
+
+                           CALL lim_rst_opn_2  ( kt )  ! Open Ice restart file
 #if ! defined key_c1d
-            ! Ice dynamics & transport (not in 1D case)
-                                        CALL lim_dyn_2      ( kt )           ! Ice dynamics    ( rheology/dynamics )
-                                        CALL lim_trp_2      ( kt )           ! Ice transport   ( Advection/diffusion )
-            IF( ln_limdmp )             CALL lim_dmp_2      ( kt )           ! Ice damping 
+                                                       ! Ice dynamics & transport (except in 1D case)
+                           CALL lim_dyn_2      ( kt )      ! Ice dynamics    ( rheology/dynamics )
+                           CALL lim_trp_2      ( kt )      ! Ice transport   ( Advection/diffusion )
+         IF( ln_limdmp )   CALL lim_dmp_2      ( kt )      ! Ice damping 
 #endif
 #if defined key_coupled
-         IF( ksbc == 5    )             CALL sbc_cpl_ice_flx( reshape( frld, (/jpi,jpj,1/) ),        &
-      &                                                       qns_tot, qns_ice, qsr_tot , qsr_ice,   &
-      &                                                       emp_tot, emp_ice, dqns_ice, sprecip,   &
+         !                                             ! Ice surface fluxes in coupled mode 
+         IF( ksbc == 5 )   CALL sbc_cpl_ice_flx( reshape( frld, (/jpi,jpj,1/) ),                 &
+      &                                                   qns_tot, qns_ice, qsr_tot , qsr_ice,   &
+      &                                                   emp_tot, emp_ice, dqns_ice, sprecip,   &
       !                                      optional arguments, used only in 'mixed oce-ice' case
-      &                                                       palbi = zalb_ice_cs, psst = sst_m, pist = sist )
+      &                                                   palbi = zalb_ice_cs, psst = sst_m, pist = sist )
 #endif
-                                        CALL lim_thd_2      ( kt )      ! Ice thermodynamics 
-                                        CALL lim_sbc_2      ( kt )      ! Ice/Ocean Mass & Heat fluxes 
+                           CALL lim_thd_2      ( kt )      ! Ice thermodynamics 
+                           CALL lim_sbc_flx_2  ( kt )      ! update surface ocean mass, heat & salt fluxes 
 
          IF( ( MOD( kt+nn_fsbc-1, ninfo ) == 0 .OR. ntmoy == 1 ) .AND. .NOT. lk_mpp )   &
-            &                           CALL lim_dia_2      ( kt )      ! Ice Diagnostics
+            &              CALL lim_dia_2      ( kt )      ! Ice Diagnostics
 # if ! defined key_iomput
-                                        CALL lim_wri_2      ( kt )      ! Ice outputs
+                           CALL lim_wri_2      ( kt )      ! Ice outputs
 # endif
-         IF( lrst_ice )                 CALL lim_rst_write_2( kt )      ! Ice restart file
+         IF( lrst_ice  )   CALL lim_rst_write_2( kt )      ! Ice restart file
          !
-      ENDIF
+      ENDIF                                    ! End sea-ice time step only
+      !
+      !                                        !--------------------------!
+      !                                        !  at all ocean time step  !
+      !                                        !--------------------------!
+      !                                               
+      !                                              ! Update surface ocean stresses (only in ice-dynamic case)
+      !                                                   ! otherwise the atm.-ocean stresses are used everywhere
+      IF( ln_limdyn    )   CALL lim_sbc_tau_2( kt, ub(:,:,1), vb(:,:,1) )  ! using before instantaneous surf. currents
       !
    END SUBROUTINE sbc_ice_lim_2
Index: /branches/nemo_v3_3_beta/NEMOGCM/NEMO/OPA_SRC/SBC/sbcmod.F90
===================================================================
--- /branches/nemo_v3_3_beta/NEMOGCM/NEMO/OPA_SRC/SBC/sbcmod.F90	(revision 2369)
+++ /branches/nemo_v3_3_beta/NEMOGCM/NEMO/OPA_SRC/SBC/sbcmod.F90	(revision 2370)
@@ -4,9 +4,10 @@
    !! Surface module :  provide to the ocean its surface boundary condition
    !!======================================================================
-   !! History :  3.0  !  2006-07  (G. Madec)  Original code
-   !!            3.1  !  2008-08  (S. Masson, A. Caubel, E. Maisonnave, G. Madec) coupled interface
-   !!            3.3  !  2010-04  (M. Leclair, G. Madec)  Forcing averaged over 2 time steps
-   !!            3.3  !  2010-10  (S. Masson)  add diurnal cycle
-   !!            3.3   !  09-2010  (D. Storkey) add ice boundary conditions (BDY)
+   !! History :  3.0  ! 2006-07  (G. Madec)  Original code
+   !!            3.1  ! 2008-08  (S. Masson, A. Caubel, E. Maisonnave, G. Madec) coupled interface
+   !!            3.3  ! 2010-04  (M. Leclair, G. Madec)  Forcing averaged over 2 time steps
+   !!            3.3  ! 2010-10  (S. Masson)  add diurnal cycle
+   !!            3.3  ! 2010-09  (D. Storkey) add ice boundary conditions (BDY)
+   !!             -   ! 2010-11  (G. Madec) ice-ocean stress always computed at each ocean time-step
    !!----------------------------------------------------------------------
 
@@ -74,5 +75,5 @@
       !!
       NAMELIST/namsbc/ nn_fsbc, ln_ana  , ln_flx, ln_blk_clio, ln_blk_core, ln_cpl    ,   &
-         &             nn_ice , ln_dm2dc, ln_rnf, ln_ssr     , nn_fwb     , nn_ico_cpl
+         &             nn_ice , ln_dm2dc, ln_rnf, ln_ssr     , nn_fwb
       !!----------------------------------------------------------------------
 
@@ -107,5 +108,4 @@
          WRITE(numout,*) '           Misc. options of sbc : '
          WRITE(numout,*) '              ice management in the sbc (=0/1/2/3)       nn_ice      = ', nn_ice 
-         WRITE(numout,*) '              ice-ocean stress computation (=0/1/2)      nn_ico_cpl  = ', nn_ico_cpl
          WRITE(numout,*) '              daily mean to diurnal cycle qsr            ln_dm2dc    = ', ln_dm2dc 
          WRITE(numout,*) '              runoff / runoff mouths                     ln_rnf      = ', ln_rnf
@@ -238,10 +238,10 @@
       
       SELECT CASE( nn_ice )                                     ! Update heat and freshwater fluxes over sea-ice areas
-      CASE(  1 )   ;       CALL sbc_ice_if   ( kt )                   ! Ice-cover climatology ("Ice-if" model)
+      CASE(  1 )   ;       CALL sbc_ice_if   ( kt )                  ! Ice-cover climatology ("Ice-if" model)
          !                                                      
-      CASE(  2 )   ;       CALL sbc_ice_lim_2( kt, nsbc )             ! LIM 2.0 ice model
-                           IF( lk_bdy ) CALL bdy_ice_frs( kt )
+      CASE(  2 )   ;       CALL sbc_ice_lim_2( kt, nsbc )            ! LIM-2 ice model
+         IF( lk_bdy )      CALL bdy_ice_frs  ( kt )                  ! BDY boundary condition
          !                                                     
-      CASE(  3 )   ;       CALL sbc_ice_lim  ( kt, nsbc, nn_ico_cpl)  ! LIM 3.0 ice model
+      CASE(  3 )   ;       CALL sbc_ice_lim  ( kt, nsbc )            ! LIM-3 ice model
       END SELECT                                              
 
Index: /branches/nemo_v3_3_beta/NEMOGCM/NEMO/OPA_SRC/SBC/sbcrnf.F90
===================================================================
--- /branches/nemo_v3_3_beta/NEMOGCM/NEMO/OPA_SRC/SBC/sbcrnf.F90	(revision 2369)
+++ /branches/nemo_v3_3_beta/NEMOGCM/NEMO/OPA_SRC/SBC/sbcrnf.F90	(revision 2370)
@@ -4,8 +4,9 @@
    !! Ocean forcing:  river runoff
    !!=====================================================================
-   !! History :  OPA  !  2000-11  (R. Hordoir, E. Durand)  NetCDF FORMAT
-   !!   NEMO     1.0  !  2002-09  (G. Madec)  F90: Free form and module
-   !!            3.0  !  2006-07  (G. Madec)  Surface module 
-   !!            3.2  !  2009-04  (B. Lemaire)  Introduce iom_put
+   !! History :  OPA  ! 2000-11  (R. Hordoir, E. Durand)  NetCDF FORMAT
+   !!   NEMO     1.0  ! 2002-09  (G. Madec)  F90: Free form and module
+   !!            3.0  ! 2006-07  (G. Madec)  Surface module 
+   !!            3.2  ! 2009-04  (B. Lemaire)  Introduce iom_put
+   !!            3.3  ! 2010-10  (R. Furner, G. Madec) runoff distributed over ocean levels
    !!----------------------------------------------------------------------
 
@@ -49,14 +50,13 @@
    REAL(wp), PUBLIC, DIMENSION(jpk)     ::   rnfmsk_z     !: river mouth mask (vert.)
 
-   TYPE(FLD), ALLOCATABLE, DIMENSION(:) ::   sf_rnf       !: structure of input river runoff (file information, fields read)
-
-   TYPE(FLD), ALLOCATABLE, DIMENSION(:) ::   sf_s_rnf     !: structure of input river runoff salinity (file information, fields read)  
-   TYPE(FLD), ALLOCATABLE, DIMENSION(:) ::   sf_t_rnf     !: structure of input river runoff temperature (file information, fields read)  
+   TYPE(FLD), ALLOCATABLE, DIMENSION(:) ::   sf_rnf       !: structure: river runoff (file information, fields read)
+
+   TYPE(FLD), ALLOCATABLE, DIMENSION(:) ::   sf_s_rnf     !: structure: river runoff salinity (file information, fields read)  
+   TYPE(FLD), ALLOCATABLE, DIMENSION(:) ::   sf_t_rnf     !: structure: river runoff temperature (file information, fields read)  
  
    REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   h_rnf        !: depth of runoff in m
    INTEGER,  PUBLIC, DIMENSION(jpi,jpj) ::   nk_rnf       !: depth of runoff in model levels
 
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpts) :: rnf_tsc_b, rnf_tsc  !: before and now 
-   !                                                                 !: temp. & sal. content of river runoffs   [K.m/s & PSU.m/s]
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpts) :: rnf_tsc_b, rnf_tsc  !: before and now T & S contents of runoffs  [K.m/s & PSU.m/s]
 
    !! * Substitutions  
@@ -65,7 +65,6 @@
    !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$
-   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
-
 CONTAINS
 
@@ -171,7 +170,7 @@
          CALL iom_rstput( kt, nitrst, numrow, 'rnf_sc_b', rnf_tsc(:,:,jp_sal) )
       ENDIF
-
       !
    END SUBROUTINE sbc_rnf
+
 
    SUBROUTINE sbc_rnf_div( phdivn )
Index: /branches/nemo_v3_3_beta/NEMOGCM/NEMO/OPA_SRC/step.F90
===================================================================
--- /branches/nemo_v3_3_beta/NEMOGCM/NEMO/OPA_SRC/step.F90	(revision 2369)
+++ /branches/nemo_v3_3_beta/NEMOGCM/NEMO/OPA_SRC/step.F90	(revision 2370)
@@ -26,14 +26,14 @@
 
    !!----------------------------------------------------------------------
-   !!   stp            : OPA system time-stepping
+   !!   stp             : OPA system time-stepping
    !!----------------------------------------------------------------------
    USE step_oce         ! time stepping definition modules 
 #if defined key_top
-   USE trcstp          ! passive tracer time-stepping      (trc_stp routine)
-#endif
-   USE asminc          ! assimilation increments    (tra_asm_inc, dyn_asm_inc routines)
-   USE stpctl          ! time stepping control            (stp_ctl routine)
-   USE restart         ! ocean restart                    (rst_wri routine)
-   USE prtctl          ! Print control                    (prt_ctl routine)
+   USE trcstp           ! passive tracer time-stepping      (trc_stp routine)
+#endif
+   USE asminc           ! assimilation increments    (tra_asm_inc, dyn_asm_inc routines)
+   USE stpctl           ! time stepping control            (stp_ctl routine)
+   USE restart          ! ocean restart                    (rst_wri routine)
+   USE prtctl           ! Print control                    (prt_ctl routine)
 
 #if defined key_agrif
@@ -44,5 +44,5 @@
    PRIVATE
 
-   PUBLIC   stp        ! called by opa.F90
+   PUBLIC   stp   ! called by opa.F90
 
    !! * Substitutions
@@ -52,7 +52,6 @@
    !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$
-   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
-   !!----------------------------------------------------------------------
-
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
 CONTAINS
 
@@ -149,10 +148,9 @@
          IF( ln_zps )    CALL zps_hde( kstp, jpts, tsb, gtsu, gtsv,  &    ! Partial steps: before horizontal gradient
             &                                      rhd, gru , grv  )      ! of t, s, rd at the last ocean level
-         IF ( .NOT. ln_traldf_grif ) THEN
-                         CALL ldf_slp( kstp, rhd, rn2b )        ! before slope of the lateral mixing
+         IF( ln_traldf_grif ) THEN                           ! before slope for Griffies operator
+                         CALL ldf_slp_grif( kstp )
          ELSE
-                         CALL ldf_slp_grif( kstp )
-                         IF ( ln_dynldf_bilap .OR. ln_dynldf_iso ) CALL ldf_slp( kstp, rhd, rn2b )
-      ENDIF
+                         CALL ldf_slp( kstp, rhd, rn2b )     ! before slope for Madec operator
+         ENDIF
       ENDIF
 #if defined key_traldf_c2d
